package be.cylab.java.wowa.training;

import java.util.ArrayList;
import java.util.List;

public class Trainer {

    private TrainerParameters parameters;

    public Trainer(TrainerParameters parameters) {
        this.parameters = parameters;
    }
/*
    public SolutionDistance run(List<double[]> data, double[] expected) {

    }

    public SolutionDistance findBestSolution(SolutionDistance[] solutions) {

    }
*/
    public List<SolutionDistance> generateInitialPopulation(int numberOfWeights, int populationSize) {
        List<SolutionDistance> population = new ArrayList<SolutionDistance>();
        for (int i = 0; i < populationSize; i++) {
            SolutionDistance solution = new SolutionDistance(numberOfWeights);
            for (int j = 0; j < numberOfWeights; j++) {
                solution.weights_p[j] = Math.random();
                solution.weights_w[j] = Math.random();
            }
            solution.normalize();
            population.add(solution);
        }
        return population;
    }

    public double getRandomDouble() {
        return 0;
    }

    public List<SolutionDistance> computeDistances(List<SolutionDistance> solutions, List<double[]> data, double[] expected) {
        for (SolutionDistance solution : solutions) {
            solution.computeScoreTo(data, expected);
        }
        return solutions;

    }
/*
    private List<SolutionDistance> rouletteWheelSelection(List<SolutionDistance> solutions, int count) {

    }

    private List<SolutionDistance> tournamentSelection(List<SolutionDistance> solutions, int count){

    }

    public List<SolutionDistance> selectParents(List<SolutionDistance> solutions, int count, int selectionMethod) {

    }

    public List<SolutionDistance> doReproduction(List<SolutionDistance> solutions) {

    }

    public List<SolutionDistance> reproduce(SolutionDistance dad, SolutionDistance mom, int cutPosition, float beta) {
        //Different compare to PHP implementation !! PHP allows to return several elements !
    }

    public List<SolutionDistance> randomlyMutateGenes(List<SolutionDistance> solutions) {

    }
*/
    public TrainerParameters getParameters() {
        return this.parameters;
    }

    public List<SolutionDistance> generateInitialPopulationAndComputeDistances(int populationSize, List<double[]> data, double[] expected) {
        int number_of_weights = data.get(0).length;
        List<SolutionDistance> initial_population = this.generateInitialPopulation(number_of_weights, populationSize);
        return this.computeDistances(initial_population, data, expected);
    }
/*
    public List<SolutionDistance> performReproduction(List<SolutionDistance> population, List<double[]> data, double[] expected) {

    }
*/
    private void checkAndCorrectNullWeightVector(SolutionDistance child) {

    }




}
